
/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include "PRO_file.h"

#include "sc_config.h"
#include "cgi_err.h"
#include "conf_sec.h"
#ifdef _SUPPORT_MULTI_LANGUAGE_
#include "sc_tool.h"
#endif

FILE *ifp = NULL;
static FILE *tfp = NULL;
static char TMPF[] = "/tmp/uXXXXXX";

#if 0				/* never used */
#ifdef V_JAPANESE
typedef struct code_trans {
   char code1[2];
   char code2[2];
   int  num;
} code_trans;

static code_trans code_ta[]={
	{{0x87,0x54},{0xfa,0x4a},10},
	{{0x87,0x82},{0xfa,0x59},1},
	{{0x87,0x84},{0xfa,0x5a},1},
	{{0x87,0x8a},{0xfa,0x58},1},
	{{0x87,0x90},{0x81,0xe0},1},
	{{0x87,0x91},{0x81,0xdf},1},
	{{0x87,0x92},{0x81,0xe7},1},
	{{0x87,0x95},{0x81,0xe3},1},
	{{0x87,0x96},{0x81,0xdb},1},
	{{0x87,0x97},{0x81,0xda},1},
	{{0x87,0x9a},{0x81,0xe6},1},
	{{0x87,0x9b},{0x81,0xbf},1},
	{{0x87,0x9c},{0x81,0xbe},1},
	{{0xed,0x40},{0xfa,0x5c},35},
	{{0xed,0x63},{0xfa,0x80},28},
	{{0xed,0x80},{0xfa,0x9c},97},
	{{0xed,0xe1},{0xfb,0x40},28},
	{{0xee,0x40},{0xfb,0x5c},35},
	{{0xee,0x63},{0xfb,0x80},35},
	{{0xee,0x80},{0xfb,0x9c},97},
	{{0xee,0xe1},{0xfc,0x40},12},
	{{0xee,0xef},{0xfa,0x40},10},
	{{0xee,0xf9},{0x81,0xca},1},
	{{0xee,0xfa},{0xfa,0x55},1},
	{{0xfa,0x54},{0x81,0xca},1},
	{{0xfa,0x5b},{0x81,0xe6},1}  
};
#endif

//----------------------------------------------------------------
// purpose: get a string from profile file
// Note: user must call OpenProfile to get the file handle (fp1)
// return: 0 - find key
//         1 - use default value
//----------------------------------------------------------------
static int GetLineFromFile(char **lbuf,FILE *fp)
{
	int	c,sz=256;
	char	*p,*buf;
	buf=(char *) malloc(sz);
	if(!buf){
	    *lbuf=NULL;
	    return 1;
	}    
	p=buf;
	while ((c=fgetc(fp)) != '\n' && c!=EOF) {
		if (p-buf ==sz-2) {
			buf=(char *) realloc(buf, sz*2);
			if(!buf){
	                        *lbuf=NULL;
	                          return 1;
	                  }    
			p=buf+sz-2;
			sz*=2;
		}
		*p++=c;
	}
	if(c=='\n')
	     *p++=c;
	if (c==EOF &&p==buf) {
		free(buf);
		*lbuf=NULL;
		return 1;
	}
	*p++='\0';
	*lbuf = buf;
	return 0;
}

int PRO_iGetStr(char *sect, char *key, char *val, int size, FILE* fp)
{
   int  i,bl;
   char *buf,*p,*p0;
   char b[MAX_LEN]; /* a line read from ini file */

   if (val==NULL || fp==NULL || key==NULL)
      return -1;

   if (sect) {
      if (PRO_i2sect(sect,fp) != OK) // section not found
         return -1;
   } else
      rewind(fp);

   if (size > MAX_LEN) {
      bl = size+MAX_KEY_LEN;
      buf = malloc(bl);
      if (!buf)
         return -1;
   } else {
      bl = sizeof(b);
      buf = b;   
   }

   i = strlen(key);
   while(fgets(buf,bl,fp))
   {
      if (buf[0]=='[')
         break; // end of section
      p=buf;
      while(*p==' ')
         p++;
      if (strncasecmp(p,key,i)==0)
      {
         p0=p+i;
         while (*p0==' ')
            p0++;
         if (*p0 != '=')
            continue;
         p0++;
/* Won't skip the space character at the begin of value...	 		 
         while (*p0==' ')
            p0++;
*/            
         p=buf+strlen(buf)-1;
         while(*p==0x0d || *p==0x0a)
            p--;
         *(p+1)=0;
         if (strlen(p0) > size)
            *(p0+size-1)=0;
         strcpy(val,p0);
         return OK;
      } //if (strncmp()
   } //while (fgets())
   return -1;
}
#endif /* never used */

static int PRO_GetStr_In(char *sect, char *key, char *val, int size, FILE* fp)
{
   int  i,bl;
   char *buf,*p_buf=NULL,*p,*p0;
   char b[MAX_LEN]; /* a line read from ini file */

   if (val==NULL || fp==NULL || key==NULL)
      return -1;

   if (sect) {
      if (PRO_2sect(sect,fp) != OK) // section not found
         return -1;
   } else
      rewind(fp);

   if (size > MAX_LEN) {
      bl = size+MAX_KEY_LEN;
      p_buf = buf = malloc(bl);
      if (!buf)
         return -1;
   } else {
      bl = sizeof(b);
      buf = b;   
   }

   i = strlen(key);
   while(fgets(buf,bl,fp))
   {
      if (buf[0]=='[')
         break; // end of section
      p=buf;
      while(*p==' ')
         p++;
      if (strncmp(p,key,i)==0)
      {
         p0=p+i;
         while (*p0==' ')
            p0++;
         if (*p0 != '=')
            continue;
         p0++;
/*	Won't skip the space character at the begin of value...	 
         while (*p0==' ')
            p0++;
*/             
         p=buf+strlen(buf)-1;
         while(*p==0x0d || *p==0x0a)
            p--;
         *(p+1)=0;
         if (strlen(p0) > size)
            *(p0+size-1)=0;
         strcpy(val,p0);
	  if(p_buf)
	  {
		  free(p_buf);
	  }
         return OK;
      } //if (strncmp()
   } //while (fgets())

   if(p_buf)
   {
   	free(p_buf);
   }
   return -1;
}

/* 
 * Halcyon update at 09/12/2007 to solve:
 *		User have to do factory default if the parameters in the config file updated...
 *		Currently, needn't
 */
int PRO_GetStr(char *sect, char *key, char *val, int size, FILE* fp)
{
	int ret = 0;
	FILE *fp_def = NULL;
	
	if (PRO_GetStr_In(sect, key, val, size, fp))
	{
		fp_def = fopen(DEF_CONF_FILE,"r+");
		if (fp_def)
		{
			ret = PRO_GetStr_In(sect, key, val, size, fp_def);
			fclose(fp_def);
		}
		else
		{
			ret = -1;
		}
	}
	return ret;
}

void GetErrMsg2(char *sect, int index, char *msg, int len)
{
	FILE *fh;
	char key[15];
	char tmp[MAX_ERR_MSGLEN];
#ifdef _SUPPORT_MULTI_LANGUAGE_
	int lang_id=0;
#endif

	memset(tmp,0,MAX_ERR_MSGLEN);
#ifdef _SUPPORT_MULTI_LANGUAGE_
	lang_id = 0;
	fh = fopen(SYSTEM_CONF,"rt");
	if(fh!=NULL)
	{
		PRO_GetInt(SEC_SYS, SYS_LANGUAGE_ID, &lang_id, fh);	
		if (!LanguageIDIsValid(lang_id))
		{
			lang_id = LANGUAGE_DEFAULT_ID;
		}
		fclose(fh);
    }
	sprintf(tmp,"%s_%s",CgiMsgFile,GetLanguageAbByID(lang_id));
#else
	sprintf(tmp,"%s",CgiMsgFile);
#endif
	fh=fopen(tmp,"r");
	if(!fh)
	{
		sprintf(msg,"Can't find file %s, Unknown Error",tmp);
		return;
	}
	sprintf(key,"%d",index);
	memset(tmp,0,MAX_ERR_MSGLEN);
	PRO_GetStr(sect,key,tmp,sizeof(tmp),fh);
	if(tmp[0]==0)
		strcpy(msg,"Unknown Error");
	else
		snprintf(msg,len,tmp);
	fclose(fh);
}


int PRO_GetInt(char *sect, char *key, int *val, FILE *fp)
{
   char buf[MAX_KEY_LEN];
   int ret;

   ret = PRO_GetStr(sect,key,buf,sizeof(buf),fp);
   if (ret==OK)
      *val = atoi(buf);

   return ret;
}

int PRO_GetLong(char *sect, char *key, long *val, FILE *fp)
{
   char buf[MAX_KEY_LEN];
   int ret;

   ret = PRO_GetStr(sect,key,buf,sizeof(buf),fp);
   if (ret==OK)
      *val = atol(buf);

   return ret;
}

#if 0
int PRO_GetStrLen(char *sect, char *key, FILE* fp)
{
   char buf[MAX_LEN];      /* a line read from ini file */
   char k[MAX_KEY_LEN];  /*  key=...  */
   int n,i,c;

   if (fp==NULL || key==NULL)
      return -1;

   if (sect) {
      if (PRO_2sect(sect,fp) != OK) // section not found
         return -1;
   } else
      rewind(fp);

   sprintf(k,"%s=",key);
   n=strlen(k);
   while(fgets(buf,n+1,fp)) //only read n bytes
   {
      if (strcmp(buf,k)==0) { //find the key
         i=0;
         c=fgetc(fp);
         while(c!='\n'&&c!=EOF)
         {
         	i++;
         	c=fgetc(fp);         
         }
         return i;
      }
      if (buf[0]=='[')
         break;  /* end of the exact section */
      if (strlen(buf)==n && buf[n-1]!='\n')
         while(fgetc(fp)!='\n');     //read the rest of this line
   } //while
   return 0;
}
#endif

int PRO_SetStr(char *sect, char *key, char *val, char *fname)
{
   char buf[MAX_LEN];  /* a line read from ini file */
   char s[MAX_KEY_LEN];
   int  len,j,i, ret=0;
   FILE *fh,*fh1;
   char IniTmp[]="/tmp/tXXXXXX";

   fh = fopen(fname,"r");
   if (fh==NULL)
   {  // file not exists, create one
      fh=fopen(fname,"w");
      if (fh==NULL)
         return -1;
      fclose(fh);
      fh=fopen(fname,"r");
   }

	// Halcyon add to skip the un-changed items to enhance the performance
	if (!PRO_GetStr(sect, key, buf, MAX_LEN, fh))
	{
		if (0 == strcmp(buf, val))	// Same as original, not to set again...
		{
			fclose(fh);
			return 0;
		}
	}
	fseek(fh, 0, SEEK_SET);
	// Halcyon add end...
   
   // create a temp file
   j = mkstemp(IniTmp);
   if (j == -1)
   {
      fclose(fh);
      return -1;
   }
   close(j);
   fh1 = fopen(IniTmp,"w");
   if (fh1==NULL) {
      fclose(fh);
      return -1;
   }

   if(sect==NULL){
      j = 0;
      len=strlen(key);
      while (fgets(buf,sizeof(buf),fh))
      {
         if ((buf[len] == '=' || buf[len] == ' ') &&
             (strncmp(buf,key,len)==0))
         {
            j = 1;
            fprintf(fh1,"%s=%s\n",key,val);
            len=strlen(buf);
            if(buf[len-1]!='\n') {
                i=fgetc(fh);
                while(i!='\n' && i!=EOF)
                     i=fgetc(fh);
            }
         }
         else {
  	    ret = fputs(buf,fh1);
	    if (ret < 0) { /* return ERROR */
		    fclose(fh);
		    fclose(fh1);
		    remove(IniTmp);
		    return -1;
	    } /* vincent: add for check error return */
	 }
      }
      if(!j)
         goto append;
      goto exit0;
   }

   if (sect[0]=='[')
      strcpy(s,sect);
   else
      sprintf(s,"[%s]",sect);
   len = strlen(s);

   while(fgets(buf,sizeof(buf),fh)) // while 1
   {
      if (buf[0]!='[') {
         ret = fputs(buf,fh1);
	 if (ret < 0) { /* return ERROR */
		 fclose(fh);
		 fclose(fh1);
		 remove(IniTmp);
		 return -1;
	 } /* vincent: add for check error return */
         continue;
      }
      if (strncmp(buf,s,len)==0) //find section
      {
         ret = fputs(buf,fh1);
	 if (ret < 0) { /* return ERROR */
		 fclose(fh);
		 fclose(fh1);
		 remove(IniTmp);
		 return -1;
	 } /* vincent: add for check error return */
         len = strlen(key);
         while(fgets(buf,sizeof(buf),fh)) // while 2
         {
            if (buf[0]=='[') { //next section
               fprintf(fh1,"%s=%s\n",key,val);
               ret = fputs(buf,fh1);
	       if (ret < 0) { /* return ERROR */
		       fclose(fh);
		       fclose(fh1);
		       remove(IniTmp);
		       return -1;
	       } /* vincent: add for check error return */
save_rest:
               while(fgets(buf,sizeof(buf),fh)) {
                  ret = fputs(buf,fh1);
		  if (ret < 0) { /* return ERROR */
			  fclose(fh);
			  fclose(fh1);
			  remove(IniTmp);
			  return -1;
		  } /* vincent: add for check error return */
	       }
               fclose(fh1);
               fclose(fh);
               sprintf(buf,"/bin/cp -f %s %s > /dev/null 2> /dev/null",IniTmp,fname);
               system(buf);
               sync();
               remove(IniTmp);
               return OK;
            }
            j=0;
            while(buf[j]==' ')
               j++;
            if (strncmp(buf+j,key,len)==0) { //find key
               //find '='
               j+=len;
               while(buf[j]==' ' )
                  j++;
               if(buf[j]!='=')
                  goto not_match;
               fprintf(fh1,"%s=%s\n",key,val);
               len=strlen(buf);
               if(buf[len-1]!='\n') {
                  j=fgetc(fh);
                  while(j!='\n' && j!=EOF)
                     j=fgetc(fh);
               }
               goto save_rest;
            }
            else { // section not match
not_match:
               ret = fputs(buf,fh1);
	       if (ret < 0) { /* return ERROR */
		       fclose(fh);
		       fclose(fh1);
		       remove(IniTmp);
		       return -1;
	       } /* vincent: add for check error return */
	    }
         } //while 2
         // end of file
         goto append; //append key=val
      } //if
      else {
         ret = fputs(buf,fh1);
	 if (ret < 0) { /* return ERROR */
		 fclose(fh);
		 fclose(fh1);
		 remove(IniTmp);
		 return -1;
	 } /* vincent: add for check error return */
      }
   } /* while */
   //section not found append the section
   if (sect[0] == '[')
      fprintf(fh1,"%s\n",sect);
   else
      fprintf(fh1,"[%s]\n",sect);
append:
   fprintf(fh1,"%s=%s\n",key,val);
exit0:
   fclose(fh);
   fclose(fh1);
   sprintf(buf,"/bin/cp -f %s %s >/dev/null 2> /dev/null",IniTmp,fname);
   system(buf);
   sync();
   remove(IniTmp);
   return OK;
}
int PRO_iSetStr(char *sect, char *key, char *val, char *fname)
{
   char buf[MAX_LEN];  /* a line read from ini file */
   char s[MAX_KEY_LEN];
   int  len,j,i, ret=0;
   FILE *fh,*fh1;
   char IniTmp[]="/tmp/tXXXXXX";
   char keybuf[MAX_KEY_LEN];

   fh = fopen(fname,"r");
   if (fh==NULL)
   {  // file not exists, create one
      fh=fopen(fname,"w");
      if (fh==NULL)
         return -1;
      fclose(fh);
      fh=fopen(fname,"r");
   }
   // create a temp file
   j = mkstemp(IniTmp);
   if (j == -1)
   {
      fclose(fh);
      return -1;
   }
   close(j);
   fh1 = fopen(IniTmp,"w");
   if (fh1==NULL) {
      fclose(fh);
      return -1;
   }

   if(sect==NULL){
      j = 0;
      len=strlen(key);
      while (fgets(buf,sizeof(buf),fh))
      {
         if ((buf[len] == '=' || buf[len] == ' ') &&
             (strncasecmp(buf,key,len)==0))
         {
            j = 1;
            memcpy(keybuf, buf, len);
            keybuf[len]='\0';
            fprintf(fh1,"%s=%s\n",keybuf,val);
            len=strlen(buf);
            if(buf[len-1]!='\n') {
                i=fgetc(fh);
                while(i!='\n' && i!=EOF)
                     i=fgetc(fh);
            }
         }
         else {
  	    ret = fputs(buf,fh1);
	    if (ret < 0) { /* return ERROR */
		    fclose(fh);
		    fclose(fh1);
		    remove(IniTmp);
		    return -1;
	    } /* vincent: add for check error return */
	 }
      }
      if(!j)
         goto append;
      goto exit0;
   }

   if (sect[0]=='[')
      strcpy(s,sect);
   else
      sprintf(s,"[%s]",sect);
   len = strlen(s);

   while(fgets(buf,sizeof(buf),fh)) // while 1
   {
      if (buf[0]!='[') {
         ret = fputs(buf,fh1);
	 if (ret < 0) { /* return ERROR */
		 fclose(fh);
		 fclose(fh1);
		 remove(IniTmp);
		 return -1;
	 } /* vincent: add for check error return */
         continue;
      }
      if (strncasecmp(buf,s,len)==0) //find section
      {
         ret = fputs(buf,fh1);
	 if (ret < 0) { /* return ERROR */
		 fclose(fh);
		 fclose(fh1);
		 remove(IniTmp);
		 return -1;
	 } /* vincent: add for check error return */
         len = strlen(key);
         while(fgets(buf,sizeof(buf),fh)) // while 2
         {
            if (buf[0]=='[') { //next section
               fprintf(fh1,"%s=%s\n",key,val);
               ret = fputs(buf,fh1);
	       if (ret < 0) { /* return ERROR */
		       fclose(fh);
		       fclose(fh1);
		       remove(IniTmp);
		       return -1;
	       } /* vincent: add for check error return */
save_rest:
               while(fgets(buf,sizeof(buf),fh)) {
                  ret = fputs(buf,fh1);
		  if (ret < 0) { /* return ERROR */
			  fclose(fh);
			  fclose(fh1);
			  remove(IniTmp);
			  return -1;
		  } /* vincent: add for check error return */
	       }
               fclose(fh1);
               fclose(fh);
               sprintf(buf,"/bin/cp -f %s %s > /dev/null 2> /dev/null",IniTmp,fname);
               system(buf);
               sync();
               remove(IniTmp);
               return OK;
            }
            j=0;
            while(buf[j]==' ')
               j++;
            if (strncasecmp(buf+j,key,len)==0) { //find key
               //find '='
               memcpy(keybuf,buf+j,len);
               keybuf[len]='\0';               
               j+=len;
               while(buf[j]==' ' )
                  j++;
               if(buf[j]!='=')
                  goto not_match;
               fprintf(fh1,"%s=%s\n",keybuf,val);
               len=strlen(buf);
               if(buf[len-1]!='\n') {
                  j=fgetc(fh);
                  while(j!='\n' && j!=EOF)
                     j=fgetc(fh);
               }
               goto save_rest;
            }
            else { // section not match
not_match:
               ret = fputs(buf,fh1);
	       if (ret < 0) { /* return ERROR */
		       fclose(fh);
		       fclose(fh1);
		       remove(IniTmp);
		       return -1;
	       } /* vincent: add for check error return */
	    }
         } //while 2
         // end of file
         goto append; //append key=val
      } //if
      else {
         ret = fputs(buf,fh1);
	 if (ret < 0) { /* return ERROR */
		 fclose(fh);
		 fclose(fh1);
		 remove(IniTmp);
		 return -1;
	 } /* vincent: add for check error return */
      }
   } /* while */
   //section not found append the section
   if (sect[0] == '[')
      fprintf(fh1,"%s\n",sect);
   else
      fprintf(fh1,"[%s]\n",sect);
append:
   fprintf(fh1,"%s=%s\n",key,val);
exit0:
   fclose(fh);
   fclose(fh1);
   sprintf(buf,"/bin/cp -f %s %s >/dev/null 2> /dev/null",IniTmp,fname);
   system(buf);
   sync();
   remove(IniTmp);
   return OK;
}

int PRO_SetInt(char *sect, char *key, int val, char *fname)
{
   char tmp[16];

   sprintf(tmp,"%d",val);
   return PRO_SetStr(sect,key,tmp,fname);
}

int PRO_DelSect(char *sect,char *fname)
{
   FILE *fp;

   fp = PRO_uopen(fname);
   if (fp == NULL)
      return -1;
   if (PRO_u2sect(sect,PRO_NWSEC) != OK) // do not keep the section name
      // section not exist
      PRO_uclose(fname,666,PRO_GIVEUP); // give up the modification
   else
      PRO_uclose(fname,666,PRO_GOWRIRST); // give up original section info
   return OK;
}

int PRO_RenSect(char *old_sect, char *new_sect, char *fname)
{
   char sec[MAX_KEY_LEN],*p;
   FILE *fp;
   int ret=0;

   fp = PRO_uopen(fname);
   if (fp == NULL)
      return -1;
   if (PRO_u2sect(old_sect,PRO_NWSEC) != OK)
   {  // section not exist, give up rename
      PRO_uclose(fname,-1,PRO_GIVEUP);
      return -1;
   }
   p = strstr(new_sect,"\n");
   if (p)
      *p = 0;
   if (new_sect[0] != '[')
   {
      sprintf(sec,"[%s]",new_sect);
      p = sec;
   }
   else
      p = new_sect;
   ret = fputs(p,fp);
   if (ret < 0) { /* return ERROR */
	   fclose(ifp);
	   ifp = NULL;
	   fclose(tfp); //fclose(fp);
	   tfp = NULL;
	   remove(TMPF);
	   return -1;
   } /* vincent: add for check error return */
   ret = fputs("\n",fp);
   if (ret < 0) { /* return ERROR */
	   fclose(ifp);
	   ifp = NULL;
	   fclose(tfp); //fclose(fp);
	   tfp = NULL;
	   remove(TMPF);
	   return -1;
   } /* vincent: add for check error return */
   PRO_uclose(fname,-1,PRO_WRIRST);
   return OK;
}

FILE * PRO_uopen(char *fn)
{
   int fd;

   ifp = fopen(fn,"r");
   if (ifp == NULL)
   {  // file not exists, create one
      ifp = fopen(fn,"w");
      if (ifp == NULL)
         return NULL;
      fclose(ifp);
      ifp = fopen(fn,"r");
   }
   strcpy(TMPF,"/tmp/uXXXXXX");
   fd = mkstemp(TMPF);
   if (fd == -1)
   {
      fclose(ifp);
      ifp = NULL;
      return NULL;
   }
   close(fd);
   tfp = fopen(TMPF,"w");
   if (tfp == NULL)
   {
      fclose(ifp);
      ifp = NULL;
      return NULL;
   }
   return tfp;
}

int PRO_uclose(char *fn, int mode, int ctrl)
{
   char buf[MAX_LEN];
   int  ret=0;

   switch (ctrl) {
   case PRO_GOWRIRST: // give up original section info
      while (fgets(buf,sizeof(buf),ifp))
      {
         if (buf[0] == '[')
         { // to the next section
            ret = fputs(buf,tfp);
    	    if (ret < 0) 
             { /* return ERROR */
		 ctrl = PRO_GIVEUP;
	    } /* vincent: add for check error return */
            break;
         }
      }
         // and continue to write the rest lines
   case PRO_WRIRST: // write the rest
	   while (fgets(buf,sizeof(buf),ifp)) 
         {
         ret = fputs(buf,tfp);
        	 if (ret < 0) 
             { /* return ERROR */
		 ctrl = PRO_GIVEUP;
		 break;
	 } /* vincent: add for check error return */
	   }
   }

   fclose(ifp);
   ifp = NULL;
   fclose(tfp);
   tfp = NULL;
   if (ctrl == PRO_GIVEUP)
   { // give up modification
      remove(TMPF);
   } else {
   	  sprintf(buf,"/bin/cp -f %s %s > /dev/null 2> /dev/null",TMPF,fn);
   	  system(buf);
   	  sync();
	  remove(TMPF);

      if(mode!=-1){
         sprintf(buf,"/bin/chmod %d %s > /dev/null 2> /dev/null",mode,fn);
         system(buf);
      }
   }
   return OK;
}

int PRO_u2sect(char *sect, int ctrl)
{
   char buf[MAX_LEN];
   char sec[MAX_KEY_LEN],*p;
   int  i=1, ln;
   int  ret=0;

   p = strstr(sect,"\n");
   if (p)
      *p = 0;
   if (sect[0] != '[')
   {
      sprintf(sec,"[%s]",sect);
      p = sec;
   }
   else
      p = sect;
   ln = strlen(p);
   while (fgets(buf,sizeof(buf),ifp))
   {
      if (strncmp(buf,p,ln)==0)
      {
            if (ctrl==PRO_WRSEC) 
            {
            ret = fputs(buf,tfp); // write the section name too
                if (ret < 0) 
                { /* return ERROR */
		    return -1;
	    } /* vincent: add for check error return */
	      }
         i=0;
         break;
      }
      ret = fputs(buf,tfp); // write the section name too
      if (ret < 0) { /* return ERROR */
	      return -1;
      } /* vincent: add for check error return */
   }
   if (i==1 && (ctrl==PRO_WRSEC))
   {  // section not found
      ret = fputs(p,tfp); // create section
      if (ret < 0) { /* return ERROR */
	      return -1;
      } /* vincent: add for check error return */
      ret = fputs("\n",tfp);
      if (ret < 0) { /* return ERROR */
	      return -1;
      } /* vincent: add for check error return */
   }

   return i;
}
int PRO_i2sect(char *sect, FILE *fp)
{
   char buf[MAX_LEN],sec[MAX_KEY_LEN],*p;
   int  ln;

   p = strstr(sect,"\n");
   if (p)
      *p = 0;
   if (sect[0] != '[')
   {
      sprintf(sec,"[%s]",sect);
      p = sec;
   }
   else
      p = sect;
   rewind(fp);
   ln = strlen(p);
   while(fgets(buf,sizeof(buf),fp))
   {
      if (buf[0] != '[')
         continue;
      if (strncasecmp(buf,p,ln)==0)
         return 0;
   }
   return 1;
}
int PRO_2sect(char *sect, FILE *fp)
{
   char buf[MAX_LEN],sec[MAX_KEY_LEN],*p;
   int  ln;

   p = strstr(sect,"\n");
   if (p)
      *p = 0;
   if (sect[0] != '[')
   {
      sprintf(sec,"[%s]",sect);
      p = sec;
   }
   else
      p = sect;
   rewind(fp);
   ln = strlen(p);
   while(fgets(buf,sizeof(buf),fp))
   {
      if (buf[0] != '[')
         continue;
      if (strncmp(buf,p,ln)==0)
         return 0;
   }
   return 1;
}

int PRO_GetMsgSize(char *sect)
{
   int i=0;
   FILE *fp;

   fp = fopen(MS_MSG_F,"r");
   if (fp == NULL)
      return 0;
   PRO_GetInt(sect,"total",&i,fp);
   fclose(fp);
   return i;
}

int PRO_GetMsgByIndex(char *sect, int start, int num, Char128 *msg, char *fn)
{
   FILE *fp;
   char buf[MAX_LEN];
   char k[MAX_KEY_LEN];
   char *p,*p0;
   int  no;

   if (fn)
      fp = fopen(fn,"r");
   else
      fp = fopen(MS_MSG_F,"r");
   if (fp == NULL)
      return -1;

   sprintf(k,"%d",start);
   if (PRO_GetStr(sect,k,(char*)msg,128,fp)!=OK)
      return -1;

   no = 1;
   while(fgets(buf,sizeof(buf),fp) && no < num)
   {
      if (buf[0]=='\n' || buf[0]=='\r' || buf[0]=='[')
         break;
      p=strchr(buf,'=');
      if (!p)
         continue;
      p0=buf+strlen(buf)-1;
      while(*p0==0x0d || *p0==0x0a)
         p0--;
      *(p0+1)=0;
      p++;  // to next char of '='
      if (p0-p < 128)
         strcpy(msg[no],p);
      else {
         strncpy(msg[no],p,127);
         msg[no][127] = 0;
      }
      no++;
   } // while

   fclose(fp);
   return no;
}

// #define PROF_TEST
#ifdef PROF_TEST
#define SECT "[CGI_COMMON]"
#define TF "cgi_msg"
int main()
{
   FILE *fp;
   int i;
   char b[128];
   Char128 msg[5];

   fp = fopen(TF,"r");
   if (fp == NULL)
      return 0;
   PRO_GetInt(SECT,"Total",&i,fp);
   printf("geti=%d\n",i);
   PRO_GetStr(SECT,"4",b,128,fp);
   puts(b);
   i = PRO_GetStrLen(SECT,"4",fp);
   printf("getstrlen=%d\n",i);

   PRO_SetInt(SECT,"2",6,TF);
   PRO_SetStr(SECT,"3","abcd",TF);
   i = PRO_GetMsgSize("NAT");
   printf("getsize=%d\n",i);
   PRO_GetMsgByIndex(SECT,1,5,msg,TF);
   for (i=0; i<5; i++)
      puts(msg[i]);
   return 0;
}
#endif

#if 0				/* never used */
int PRO_SetMultiItemStr(char *sect,multi_items *val,int itemnum, char *fname)
{
   int len,i;
   char *buf;
   char systmp[MAX_LEN];
   char s[MAX_SECTION_LEN];
   FILE	*fh,*fp;
   char tmpf[16]="/tmp/pXXXXXX";
   int  ret=0;

   if(!val||!fname)
      return 1;
   fp=fopen(fname,"r");
   if(!fp)
		return(1);
   i = mkstemp(tmpf);
   if (i == -1)
   {
      fclose(fp);
      return 1;
   }
   close(i);
   fh=fopen(tmpf,"w");
   if(!fh) 
   {
		fclose(fp);
      remove(tmpf);
		return(1);
   } 
   for(i=0;i<itemnum;i++)
		(val+i)->flag=0;

  	if(sect)//!=NULL
  	{
  	   if (sect[0]=='[')
	      strcpy(s,sect);
	   else
	      sprintf(s,"[%s]",sect);
	   len = strlen(s);

  		while(!GetLineFromFile(&buf,fp)) // while 1
	   {
	     	if (buf[0]!='[') 
	     	{
	         ret = fputs(buf,fh);
		 if (ret < 0) { /* return ERROR */
			 free(buf);
			 fclose(fp);
			 fclose(fh);
			 remove(tmpf);
			 return -1;
		 } /* vincent: add for check error return */
	         free(buf);
	         continue;
	     	}
	      if (strncmp(buf,s,len)==0) //find section
	      {
	         ret = fputs(buf,fh);
		 if (ret < 0) { /* return ERROR */
			 free(buf);
			 fclose(fp);
			 fclose(fh);
			 remove(tmpf);
			 return -1;
		 } /* vincent: add for check error return */
	         free(buf);

	         while (!GetLineFromFile(&buf,fp)&&buf[0]!='[')
		      {
					int founditem;

				   for(i=0,founditem=0;i<itemnum;i++)
		         {
						len=strlen((val+i)->key);
		         	if((buf[len]=='='||buf[len]==' ')&&strncmp(buf,(val+i)->key,len)==0)
		         	{
		               fprintf(fh,"%s%c%s\n",(val+i)->key,buf[len],(val+i)->value);
		         		(val+i)->flag=1;
							founditem=1;
		         		break;
		         	}
		         }
				   if(!founditem) {
					   ret = fputs(buf,fh); 
					   if (ret < 0) { /* return ERROR */
						   free(buf);
						   fclose(fp);
						   fclose(fh);
						   remove(tmpf);
						   return -1;
					   } /* vincent: add for check error return */
				   }
		      		free(buf);
		  		}
		  		for(i=0;i<itemnum;i++)
		  		{
		  			if ((val+i)->flag==0)
		      		fprintf(fh,"%s=%s\n",(val+i)->key,(val+i)->value);
		  		}

		  		if(buf)
		  		{
		  			ret = fputs(buf,fh);
					if (ret < 0) { /* return ERROR */
						free(buf);
						fclose(fp);
						fclose(fh);
						remove(tmpf);
						return -1;
					} /* vincent: add for check error return */
		  			free(buf);

	      		while(!GetLineFromFile(&buf,fp))
     	        {
                    ret = fputs(buf,fh);
		    if (ret < 0) { /* return ERROR */
			    free(buf);
			    fclose(fp);
			    fclose(fh);
			    remove(tmpf);
			    return -1;
		    } /* vincent: add for check error return */
                    free(buf);
	      		}
	      	}
		    	fclose(fh);
		    	fclose(fp);

		    	sprintf(systmp,"/bin/cp -f %s %s > /dev/null 2> /dev/null",tmpf,fname);
		    	system(systmp);
		    	sync();
		    	remove(tmpf);
		   	    return OK;
	     	}//end if
	      else// not the same section
	      {
	      	ret = fputs(buf,fh);
		if (ret < 0) { /* return ERROR */
			free(buf);
			fclose(fp);
			fclose(fh);
			remove(tmpf);
			return -1;
		} /* vincent: add for check error return */
	      	free(buf);
	      	continue;
	      }
		}//end while
		return -1; //not found section
  	}//end if(section)
  	else
  	{
      while (!GetLineFromFile(&buf,fp))
      {
			int found;

         for(i=0,found=0;i<itemnum;i++)
         {
				len=strlen((val+i)->key);
         	if((buf[len]=='='||buf[len]==' ')&&strncmp(buf,(val+i)->key,len)==0)
         	{
         		fprintf(fh,"%s%c%s\n",(val+i)->key,buf[len],(val+i)->value);
         		(val+i)->flag=1;
					found=1;
         		break;
         	}
         }

	 if(!found) {
		 ret = fputs(buf,fh);
		 if (ret < 0) { /* return ERROR */
			 free(buf);
			 fclose(fp);
			 fclose(fh);
			 remove(tmpf);
			 return -1;
		 } /* vincent: add for check error return */
	 }
			free(buf); 
      }
  	}
  	for(i=0;i<itemnum;i++)
  	{
  		if((val+i)->flag==0)
      	fprintf(fh,"%s=%s\n",(val+i)->key,(val+i)->value);
  	}
  	fclose(fh);
  	fclose(fp);
  	sprintf(systmp,"/bin/cp -f %s %s > /dev/null 2> /dev/null",tmpf,fname);
 	system(systmp);
 	sync(); 
 	remove(tmpf);
    return OK;
}

#ifdef V_JAPANESE
static void tx3_2_in(char *str, int bs2)
#else
void DBCS_CAP2SJIS(char *str, int bs2)
#endif
{
   unsigned char *p0, *p1, *buf;
   int  ev = 0;

   ev = strlen(str);
   buf = p0 = (unsigned char *)malloc(ev+1);
   p1 = str;
   while (*p1)
   {
      if (*p1 == ':')
      {
         ev = 0;
         p1++;
         switch (*p1)
         {
         case '2':
            if (*(p1+1) == 'e') // '.'
            {
               *p0 = 0x2e;
               p1++;
            }
            else
            if (*(p1+1) == 'f') // '/'
            {
               *p0 = 0x2f;
               p1++;
            }
            else
               goto caseD;
            break;
         case '7':
            if (*(p1+1) == 'f')
            {
               *p0 = 0x7f;
               p1++;
               ev = 1;
            }
            else
               goto caseD;
            break;
         case '8': case '9':
            if (*(p1+1) >= 'a' && *(p1+1) <= 'f')
            {
               *p0 = *p1 - '0';
               *p0 <<= 4; 
               p1++;
               *p0 += *p1 - 'a' + 10;
               ev = 1;
            }
            else
            if (*(p1+1) >= '0' && *(p1+1) <= '9')
            {
               *p0 = *p1 - '0';
               *p0 <<= 4; 
               p1++;
               *p0 += *p1 - '0';
               ev = 1;
            }
            else
            {
               *p0 = ':';
               p0++;
               *p0 = *p1;
            }
            break;
         case 'a': case 'b': case 'c':
         case 'd': case 'e': case 'f':
            if (*(p1+1) >= 'a' && *(p1+1) <= 'f')
            {
               *p0 = *p1 - 'a' + 10;
               *p0 <<= 4; 
               p1++;
               *p0 += *p1 - 'a' + 10;
               ev = 1;
            }
            else
            if (*(p1+1) >= '0' && *(p1+1) <= '9')
            {
               *p0 = *p1 - 'a' + 10;
               *p0 <<= 4; 
               p1++;
               *p0 += *p1 - '0';
               ev = 1;
            }
            else
            {
               *p0 = ':';
               p0++;
               *p0 = *p1;
            }
            break;
         default:
caseD:
            *p0 = ':';
            p1--;
         } // switch
      } // ':'
      else
      if (*p1 == '\\' && bs2 && !ev)
      {
         *p0++ = '\\';
         *p0 = '\\';
      }
      else
      if (*p1 >= 0x7f)
      {
         ev = 0;
         *p0++ = *p1++;
         *p0 = *p1;
      }
      else
      {
         ev = 0;
         *p0 = *p1;
      }
      p1++;
      p0++;
   } // while (*p1)
   *p0 = 0;
   strcpy(str,buf);
   free(buf);
}
#ifdef V_JAPANESE
static void tx2_3_in(char *str, int bs2)
#else
void DBCS_SJIS2CAP(char *str, int bs2)
#endif
{
   unsigned char *buf;
   unsigned char *p0, *p1;
   int ln;

   ln = strlen(str);
   buf = p0 = (unsigned char *)malloc(ln*3+1);
   p1 = str;
   while (*p1)
   {
      if (*p1 >= 0x7f)
      {
         *p0++ = ':';
         sprintf(p0,"%x",*p1);
         p0++;
      } else
      if (*p1 == '\\' && bs2)
      {
         *p0++ = '\\';
         *p0 = '\\';
      }
      else
         *p0 = *p1;
      p0++;
      p1++;
   } // while (*p1)
   *p0 = 0;
   strcpy(str,buf);
   free(buf);
}

int DBCS_AnyDBCSInStr(char *str)
{
   int i;

   for(i=0;i<strlen(str);i++){
      if((unsigned char)(str[i])>0x7f)
         return(1);
   }
   return(0);
}

//-----------------------------------------------------------------
// purpose : input the code string ,and trasfer to the special string.
// input :  str -- want to transfer string.
//	    flag -- trans form
//             0 - code1 -->code2
//             1 - code2 -->code1
// output : str1 -- the transfered string.
// note :  fininsh use this function must free str1.
// -----------------------------------------------------------------
#ifdef V_JAPANESE
void code_transfer(unsigned char *input,unsigned char ** output,int flag)
{
	int i,j,k,len,code_num;
	unsigned char c0,c1,c2,c3;
	unsigned char *p,*q;
		
	code_num = sizeof(code_ta) / sizeof(struct code_trans);
	len = strlen(input);
	*output = (unsigned char*)malloc(len+1);
	strcpy(*output,input);
	p = q = (unsigned char *)*output;
	for(i =0;i<len;i++)
	{	
		for(j=0;j<code_num;j++)
		{	
			if(!flag)
			{
				c0=code_ta[j].code1[0];
				c1=code_ta[j].code1[1];
				c2=code_ta[j].code2[0];
				c3=code_ta[j].code2[1];
			}
			else 
			{
				c0=code_ta[j].code2[0];
				c1=code_ta[j].code2[1];
				c2=code_ta[j].code1[0];
				c3=code_ta[j].code1[1];
			}
			if((*p)==c0)
			{	
				q=p+1;
				for(k=0;k<code_ta[j].num;k++)
				{
					if((*q)==(c1+k))
					{
						*p = c2;
						*q = c3+k;
						p ++;
						i ++;
						break;
					}
						
				}		
			}	
		}
		p = p+1;
		q = p;
	}
	return;
}
#endif

//----------------------------------------------------------
// purpose : examine the path_str valid
// input :  str -- path string
// return : 0 -- valid
// 	    1 -- invalid
// note : invalid condition 
//              1.   str_len >=246
//              2.   path_len >=126
//              3.   file_len >=126
//---------------------------------------------------------
int DBCS_CheckFileName(char *str2)
{
	#define MAX_LEN_CAP_LEN 	255
	#define MAX_LEN_SJIS_LEN	126
	#define MAX_FULL_PATH		255
	
	int len;
	char buf[16];
	char * s,*p;
	FILE *fp;
	char *str;

//get server name
	fp=fopen("/etc/CGI_ds.conf","rt");
	PRO_GetStr("network","disk_server_name",buf,16,fp);
	fclose(fp);
	
// check normal charactor and SJIS charactor
	len = strlen(str2);
	if(len >=(MAX_FULL_PATH-strlen(buf)-13)) //13: \\xxx\Admin_only
		return 1;

	s = str2+1;
	p = strchr(s,'/');
	while(p != NULL)
	{
		len = p - s;
		if(len>MAX_LEN_SJIS_LEN)
			return 1;
		s = p+1;
		p = strchr(s,'/');
	}

	len = strlen(s);
	if(len >MAX_LEN_SJIS_LEN)
		return 1;
		
// check CAP charactor	
	str=malloc(strlen(str2)*3+1);	
	strcpy(str,str2);
	DBCS_SJIS2CAP(str,0);
	s = str+1;
	p = strchr(s,'/');
	while(p != NULL)
	{
		len = p - s;
		if(len>=MAX_LEN_CAP_LEN)
			return 1;
		s = p+1;
		p = strchr(s,'/');
	}
	len = strlen(s);
	free(str);
	if(len >=MAX_LEN_CAP_LEN)
		return 1;
	return 0;
}
#ifdef V_JAPANESE
void DBCS_SJIS2CAP(char *input,int t23flag)
{
   unsigned char *output;
   unsigned char *buf;
   code_transfer(input,&output,0);

   buf=(unsigned char *)malloc(strlen(output)*3+1);
   strcpy(buf,output);
   free(output);
   tx2_3_in(buf,t23flag);
   strcpy(input,buf);
   free(buf);
}
	
void DBCS_CAP2SJIS(char *input,int t23flag)
{
   unsigned char *output;

   tx3_2_in(input,t23flag);
   code_transfer(input,&output,1);
   input=output;
   free(output);
}
#endif

//--------------------------------------------
// purpose: add '\\' before special characters
// input: old - source string
//        str - special character string
// output: new - dest string
//--------------------------------------------
void DBCS_SpecialChar(char *old, char *new,char *str)
{
   char *p,*p1;
   int len,i;

   len=strlen(str);
   p=old;
   p1=new;
   while(*p){
     for(i=0;i<len;i++){
        if(*p==str[i])
           break;
     }
     if(i<len)
       *p1++='\\';
     *p1++=*p++;
   }
  *p1=0;
}




#endif /* never used */

