/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2006.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/

#ifndef __SC_TOOL_C__
#define __SC_TOOL_C__

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>

#include "sc_tool.h"
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <sys/stat.h>
#include <pthread.h>
#include <arpa/nameser.h>
#include <resolv.h>
#include "time.h"
#include "system_def.h"

int tx_quot(char *buf,char *s,int blen)
{
   int i,j,len;

   memset(buf,0,blen);
   len=strlen(s);
   for(i=0,j=0;i<len;i++){
        if(s[i]!='"')
           buf[j++]=s[i];
        else{
           strcat(buf,"&quot;");
           j+=6;
        }
   }
   return(0);
}

static int GetAppsPidIn(char *name, char *spec_file)
{
#define SC_TMP_FILENAME_LEN			80	
	char tmp[SC_TMP_FILENAME_LEN+1];
	char pidfile[SC_TMP_FILENAME_LEN+1];
	FILE *fh;
	char *pstr;
	char *token=" \r\n";
	int find=0,p=0;

	if (spec_file)
	{
		strncpy(pidfile, spec_file, SC_TMP_FILENAME_LEN);
	}
	else
	{
		snprintf(pidfile, SC_TMP_FILENAME_LEN, "/tmp/%s%ld", name, time(NULL));
		snprintf(tmp, SC_TMP_FILENAME_LEN, "/bin/pidof %s > %s 2>/dev/null", name, pidfile);
		//printf("tmp=%s\n", tmp);
		system(tmp);
	}
	fh=fopen(pidfile, "r");
	if(!fh)
	{
		if (NULL == spec_file)
		{
			remove(pidfile);
		}
		//SC_LINE;
		return(0);
	}
	while (fgets(tmp,sizeof(tmp),fh)!=0)
	{
		pstr=strtok(tmp,token);
		if(pstr)
		{
			find=1;
			p=atoi(tmp);
			break;
		}
	}
	fclose(fh);

	if (NULL == spec_file)
	{
		remove(pidfile);
	}
	if(!find)
	{
		//SC_LINE;
		return(0);
	}
	else
	{
		return(p);
	}
}

int GetAppsPid(char *name)
{
	return GetAppsPidIn(name, NULL);
}

/*
 *
 */
int SendSignal2Apps(char *app_name, int signal)
{
	int pid;
	//char buffer[256];

	if ((pid = GetAppsPid(app_name)))
	{
		return kill(pid, signal);
		/*
		sprintf(buffer, "/usr/bin/kill -%s %d >/dev/null 2>/dev/null ", signal, pid);
		if (dae_flag)
		{
			strcat(buffer, " & ");
		}
		system(buffer);
		*/
	}
	return 0;
}

int GetAppsPidBySpecFile(char *name, char *filename)
{
	return GetAppsPidIn(name, filename);
}

int SendSignal2AppsBySpecFile(char *name, int signal, char *filename)
{
	int pid;
	//char buffer[256];

	if ((pid = GetAppsPidBySpecFile(name, filename)))
	{
		return kill(pid, signal);
		/*
		sprintf(buffer, "/usr/bin/kill -%s %d >/dev/null 2>/dev/null ", signal, pid);
		if (dae_flag)
		{
			strcat(buffer, " & ");
		}
		system(buffer);
		*/
	}
	return 0;
}

#ifdef _SC_CHECK_PORT_USED_OR_NOT_
int CheckCanUsePort(int port,int proType)
{
    int sfd;
    int err = 1;
    struct sockaddr_in sockadr;

	if (STREAM_SOCKET_TYPE == proType)
	{
	    sfd = socket(PF_INET, SOCK_STREAM, 0);
	    if (-1 != sfd) 
	    {
	        memset(&sockadr, 0, sizeof(sockadr));
	        sockadr.sin_family		= AF_INET;
	        sockadr.sin_addr.s_addr	= htonl(INADDR_ANY);
	        sockadr.sin_port		= htons(port);
	        if (!bind(sfd, (struct sockaddr *)&sockadr, sizeof(sockadr)))
	        {
	            err = 0;
	        }
	        close(sfd);
	    }
	}
	else if (DGRAM_SOCKET_TYPE == proType)
	{
		err = 0;
	}
	return err;
}
#endif

#ifdef _SUPPORT_MULTI_LANGUAGE_
#if 1
static char *LanguageStringTab[LAN_ID_MAX] = 
{
	"en",	// 0x0
	"en",	// 0x1
	"fr",	// 0x2
	"de",	// 0x3
	"sv",	// 0x4
	"es",	// 0x5
	"it",	// 0x6
	"pt",	// 0x7
	"dk",	// 0x8
	"du",	// 0x9
	"",	// 0x0a
	"",	// 0x0b
	"",	// 0x0c
	"",	// 0x0d
	"",	// 0x0e
	"",	// 0x0f
	"",	// 0x10
	"",	// 0x11
	"",	// 0x12
	"",	// 0x13
	"us",	// 0x14
	"sc",	// 0x15
	"tc",	// 0x16
	"au",	// 0x17
	"jp",	// 0x18
	"kr"	// 0x19
};
#else
typedef struct LanguageStringS
{
	int id;
	char *ab;
	char *fullname;
} LanguageStringS;
static LanguageStringS LanguageStringTab[] =
{
	//{0x00, "cn", "Simplified Chinese"},
	{0x00, "en", "English"}, // default value
	{0x01, "en", "English"},
	{0x02, "fr", "French"},
	{0x03, "de", "German"},
	{0x04, "sv", "Swedish_SE"},
	{0x05, "es", "Spanish"},
	{0x06, "it", "Italian"},
	{0x07, "pt", "Portugal"},
	{0x08, "dk", "Denmark"},
	{0x09, "du", "Dutch"},
	{0x14, "us", "America English"},
	{0x15, "sc", "Simplified Chinese"},
	{0x16, "tc", "Traditional Chinese"},
	{0x17, "au", "Australia English"},
	{0x18, "jp", "Japanese"},
	{0x19, "kr", "Korean"},
	{-1, NULL, NULL},
};
#endif

char *GetLanguageAbByID(int id)
{
	if (!LanguageIDIsValid(id))
	{
		id = LANGUAGE_DEFAULT_ID;
	}
	return LanguageStringTab[id];
/*	
	LanguageStringS *p = LanguageStringTab;
	
	while (p->id >= 0)
	{
		if (p->id == id)
		{
			return p->ab;
		}
		p ++;
	}
	return LanguageStringTab[0].ab;
*/	
}
int GetLanguageIDByAb(char *ab)
{
	int i;

	for (i = 0; i < LAN_ID_MAX; i ++)
	{
		if (!strcmp(ab, LanguageStringTab[i]))
		{
			return i;
		}
	}
	return 0;
	/*
	LanguageStringS *p = LanguageStringTab;
	
	while (p->id >= 0)
	{
		if (0 == strcmp(ab, p->ab))
		{
			return p->id;
		}
		p ++;
	}
	return 0;
	*/
}

typedef struct lang_id_match_str
{
	int lang_id;
	char *name;
}LangIDMatchStr;

static LangIDMatchStr LangOCXString[]=
{
#if defined(_LANGUAGE_CA_)
	{LAN_ID_ENGLISH,"ENU"},
	{LAN_ID_FRENCH,"FRA"},
#elif defined(_LANGUAGE_EU_)
	{LAN_ID_ENGLISH,"ENU"},
	{LAN_ID_FRENCH,"FRN"},
	{LAN_ID_GERMAN,"DEU"},
	{LAN_ID_SPANISH,"ESN"},	
	{LAN_ID_ITALIAN,"ITA"},
	{LAN_ID_PORTUGAL,"PTG"},
	{LAN_ID_DUTCH,"NLD"},
#else	// US
	{LAN_ID_USA,"USA"},
#endif
	{-1,NULL}
};

static int LanguageIDValidTab[] =
{
#if defined(_LANGUAGE_CA_)
	LAN_ID_ENGLISH, LAN_ID_FRENCH,	
#elif defined(_LANGUAGE_EU_)
	//Here must be this order(alphabetical)
	LAN_ID_GERMAN,	LAN_ID_ENGLISH, LAN_ID_SPANISH, LAN_ID_FRENCH, LAN_ID_ITALIAN, LAN_ID_DUTCH, LAN_ID_PORTUGAL,
#elif defined(_SUPPORT_MULTI_LANGUAGE_SIMULTANEOUS_)
		//Here must be this order(alphabetical)
	LAN_ID_GERMAN,	LAN_ID_ENGLISH, LAN_ID_SPANISH, LAN_ID_FRENCH, LAN_ID_ITALIAN, LAN_ID_DUTCH, LAN_ID_DUTCH,

#else	// US
	LAN_ID_USA,
#endif
	-1
};
/*
 * 1 is valid, 0 invalid
 */
int LanguageIDIsValid(int language_id)
{
	int i = 0;
	
	if (language_id < 0 || language_id >= LAN_ID_MAX)
	{
		return 0;
	}
	else
	{
		while (LanguageIDValidTab[i] >= 0)
		{
			if (language_id == LanguageIDValidTab[i])
			{
				return 1;
			}
			i ++;
		}
		return 0;
	}
	/*
	LanguageStringS *p = LanguageStringTab;
	
	while (p->id >= 0)
	{
		if (p->id == language_id)
		{
			return 1;
		}
		p ++;
	}
	return 0;
	*/
}

int GetDateFormatByLanguageID(int lang_id)
{
#ifndef _LANGUAGE_CA_
	if (LAN_ID_PORTUGAL == lang_id
	|| LAN_ID_FRENCH == lang_id
	|| LAN_ID_GERMAN == lang_id
	|| LAN_ID_SPANISH == lang_id
	|| LAN_ID_ITALIAN == lang_id
	|| LAN_ID_DUTCH == lang_id
	)
	{
		return DATE_TYPE_INDEX_2;
	}
	else
#endif
	{
		return DATE_TYPE_INDEX_1;
	}
}


int *LanguageIDListSupported(void)
{
	return LanguageIDValidTab;
}

char *GetLangOCXStrByID(int id)
{
	LangIDMatchStr *p = LangOCXString;
	
	while (p->lang_id >= 0 && p->name!=NULL)
	{
		if (p->lang_id== id)
		{
			return p->name;
		}
		p ++;
	}
	return LangOCXString[0].name;
}
#endif

static pthread_mutex_t gethostbyname_lock;
static int gethostbyname_lock_tid = -1;
static int gethostbyname_lock_init=0;
static struct stat dns_file_status;
#define DNS_CONF	"/etc/resolv.conf"

static struct hostent *sc_gethostbyname_r_in(const char *name, struct hostent *result_buf, char *buf, size_t buflen)
{	
	struct hostent *hp;	
	struct stat tmp_dns_file;
	
	stat(DNS_CONF,&tmp_dns_file);
	if (0 == dns_file_status.st_mtime || tmp_dns_file.st_mtime != dns_file_status.st_mtime)
	{
		res_init();
		memcpy(&dns_file_status,&tmp_dns_file,sizeof(struct stat));
	}
	gethostbyname_r(name, result_buf, buf, buflen, &hp, &h_errno);
	return hp;
}

static void pthread_cleanup_push_catch(void *arg)
{
	//char buffer[200];

	//sprintf(buffer, "echo 1111 tid=%d, self=%d >> /tmp/test.txt", gethostbyname_lock_tid, (int)pthread_self());
	//system(buffer);

	if (gethostbyname_lock_tid > 0 && gethostbyname_lock_tid == pthread_self())
	{
		//system("echo YYYY >> /tmp/test.txt");
		pthread_mutex_unlock(&gethostbyname_lock);
	}
	//system("echo Out pthread_cleanup_push_catch >> /tmp/test.txt");
}
struct hostent *sc_gethostbyname_r_block(const char *name, struct hostent *result_buf, char *buf, size_t buflen)
{	
	struct hostent *hp;	
	
	if (!gethostbyname_lock_init)
	{
		pthread_mutex_init(&gethostbyname_lock, NULL);
		gethostbyname_lock_init = 1;
	}

	//system("echo Start gethostbyname_r_block >> /tmp/test.txt");

	pthread_cleanup_push(pthread_cleanup_push_catch, (void *)NULL);
	
	pthread_mutex_lock(&gethostbyname_lock);
	gethostbyname_lock_tid = pthread_self();
	hp = sc_gethostbyname_r_in(name, result_buf, buf, buflen);
	//system("echo Before sleep >> /tmp/test.txt");
	//sleep(20);
	gethostbyname_lock_tid = -1;	// Here still are the competition issue..., Halcyon add at 03/14/2008

	//system("echo Before pthread_cleanup_pop >> /tmp/test.txt");
	pthread_cleanup_pop(0);		
	//system("echo End pthread_cleanup_pop >> /tmp/test.txt");

	pthread_mutex_unlock(&gethostbyname_lock);


	return hp;
}
int free_gethostbyname_lock(void)
{
	pthread_mutex_destroy(&gethostbyname_lock);
	gethostbyname_lock_init = 0;
	return 0;
}

struct hostent *sc_gethostbyname(const char *name)
{	
	static struct hostent h;
	static char buf[sizeof(struct in_addr) +
		sizeof(struct in_addr *)*2 +
		sizeof(char *)*(8) + 384/*namebuffer*/ + 32/* margin */+512/*enlarge the buffer*/];
	
	return sc_gethostbyname_r_in(name, &h, buf, sizeof(buf));
}




/*
int main(int argc, char *argv[])
{
	printf("%d\n", GetAppsPid(argv[1]));
	return 0;
}
*/

#ifdef _ONE_FW_MULTI_MODEL_
/*
 * 0 success, others fail
 */
int sc_get_real_model_name(char *model, int model_len)
{
	FILE *fd;
	int ret = 0;
	
	if (NULL == model || model_len <= 0)
	{
		return -1;
	}

	//fprintf(stderr, "%s(%d): len=%d, model=%s\n", __FUNCTION__, __LINE__, model_len, model);
	fd = fopen(SC_MODEL_REAL_NAME_FILE, "rt");
	if (NULL == fd)
	{
		strcpy(model, SC_MODEL_NAME);
		return 0;
	}	
	ret = fread(model, 1, model_len, fd);
	fclose(fd);
	if (ret < 0)
	{
		strcpy(model, SC_MODEL_NAME);
		return 0;
	}
	model[ret] = 0;
	//fprintf(stderr, "%s(%d): len=%d, model=%s\n", __FUNCTION__, __LINE__, model_len, model);
	return 0;
}
#endif

#ifdef _SUPPORT_NEWEST_TIMEZONE_AS_VISTA_
typedef struct 
{
	int resv;
	int correction; //if this timezone is not support now, use the default value to support
}TimeZoneResv;

#define TIMEZONE_NULL		-1
TimeZoneResv g_timezone_resv[] =
{
	{33, 32},
	{TIMEZONE_NULL,TIMEZONE_NULL},
};

/*
Description: check the timezone whether the timezone is support before you set the timezone
return:  0 ->the timezone is valid;  -1 ->the timezone is unvalid
*/
int TIME_TimezoneCheck(int timezone)
{
	int i=0;
	
	if(timezone < TIMEZONE_MIN || timezone >TIMEZONE_MAX)
	{
		return -1;
	}
	
	while(TIMEZONE_NULL != g_timezone_resv[i].resv)
	{
		if(g_timezone_resv[i].resv == timezone)
		{
			return -1;
		}
		else
		{
			i++;
		}
	}

	return 0;
}

/*
Description: Correcting the value of timezone before you use the timezone
*/
void TIME_TimezoneCorrect(int * p_timezone)
{
	int i=0;

	if(*p_timezone < TIMEZONE_MIN || *p_timezone >TIMEZONE_MAX)
	{
		*p_timezone = TIMEZONE_DEFAULT;
	}
	
	while(TIMEZONE_NULL !=g_timezone_resv[i].resv)
	{
		if(g_timezone_resv[i].resv == *p_timezone)
		{
			*p_timezone =g_timezone_resv[i].correction;
			return;
		}
		else
		{
			i++;
		}
	}
}
#endif

// When time() get device time, it will treate the time as GMT time.
// So it will auto add the timezone hours. e.g. (GMT +5), if device time
// is 5:00, use time(), it will get time 10:00. But, our device's time 
// is the time had added the timezone hours. Another world, if device's time
// is 5:00, the GMT time is 0:00. So we will reduce timezone hours after time().
// When 5:00, time() will get 10:00 ,we reduce 5 hours, it will be 5:00 back. So it is right. 
int sc_time_zone[TZ_NO]={  
-1200,-1100,-1000,-900,-800,	//index: 0 ~4						
-700,-700,-700, -600,-600,							
-600,-600, -500,-500,-500,											
-400,-400,-400, -350,-300,											
-300,-300,-200,-100,-100,
0,      0,   100,100,100,
100,100,200,200,200,
200,200,200,300,300,
300,300,350,400,400,
450,500,500,550,575,
600,600,
#ifdef _SUPPORT_NEWEST_TIMEZONE_AS_VISTA_
550,
#else
600,
#endif
650,700,
700,800,800,800,800,
800,900,900,900,950,
950,1000,1000,1000,1000,
1000,1100,1200,1200,1300, //index: 70 ~74
-450, -800,-400,-300,200,  //index: 75 ~89
200,200,300,400,200,		//index: 80 ~84
};

int *get_time_zone_table()
{
	return sc_time_zone;
}

#endif

