/***************************************************************
 * (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2006.
 *
 *      Use of this software is restricted to the terms and
 *      conditions of SerComm's software license agreement.
 *
 *                        www.sercomm.com
 ****************************************************************/

#ifndef __SC_TOOL_H__
#define __SC_TOOL_H__

#include "sc_config.h"
#include <signal.h>
#include <netdb.h>

int tx_quot(char *buf,char *s,int blen);
int GetAppsPid(char *name);
int SendSignal2Apps(char *app_name, int signal);

#define APPS_NAME_HYDRA			"hydra"
#define LOCK_FILENAME_HYDRA		"/tmp/hydra.lock"
int GetAppsPidBySpecFile(char *name, char *filename);
int SendSignal2AppsBySpecFile(char *name, int signal, char *filename);

#ifdef _SC_CHECK_PORT_USED_OR_NOT_
#define STREAM_SOCKET_TYPE		1
#define DGRAM_SOCKET_TYPE		2
#define SEQPACKET_SOCKET_TYPE	3
#define RAW_SOCKET_TYPE			4
#define RDM_SOCKET_TYPE			5
#define PACKET_SOCKET_TYPE		6
/************************************************
*name:	CheckCanUsePort
*input:	port - need check port
*return:0 - can use.
*return:1 - have been used.Can't sue
************************************************/
int CheckCanUsePort(int port,int proType);
#endif

#ifdef _SUPPORT_MULTI_LANGUAGE_
typedef enum
{
	LAN_ID_DEFAULT,		// 0
	LAN_ID_ENGLISH,		// 1
	LAN_ID_FRENCH,		// 2
	LAN_ID_GERMAN,		// 3
	LAN_ID_SWEDISHSE,		// 4
	LAN_ID_SPANISH,		// 5
	LAN_ID_ITALIAN,		// 6
	LAN_ID_PORTUGAL,		// 7
	LAN_ID_DENMARK,		// 8
	LAN_ID_DUTCH,		// 9
	LAN_ID_RESERVE0X0A,		// 10
	LAN_ID_RESERVE0X0B,		// 11
	LAN_ID_RESERVE0X0C,		// 12
	LAN_ID_RESERVE0X0D,		// 13
	LAN_ID_RESERVE0X0E,		// 14
	LAN_ID_RESERVE0X0F,		// 15
	LAN_ID_RESERVE0X10,		// 16
	LAN_ID_RESERVE0X11,		// 17
	LAN_ID_RESERVE0X12,		// 18
	LAN_ID_RESERVE0X13,		// 19
	LAN_ID_USA,		// 20
	LAN_ID_SIMPLECHINA,		// 21
	LAN_ID_TRADITIONALCHINA,		// 22
	LAN_ID_AUSTRALIA,		// 23
	LAN_ID_JAPANESE,		// 24
	LAN_ID_KOREAN,		// 25
	LAN_ID_MAX		// 26
} LanguageID;

#if defined(_LANGUAGE_CA_)
	#define LANGUAGE_DEFAULT_ID		LAN_ID_ENGLISH
#elif defined(_LANGUAGE_EU_)
	#define LANGUAGE_DEFAULT_ID		LAN_ID_ENGLISH
#elif defined(_SUPPORT_MULTI_LANGUAGE_SIMULTANEOUS_)
	#define LANGUAGE_DEFAULT_ID		LAN_ID_ENGLISH	
#else	// US
	#define LANGUAGE_DEFAULT_ID		LAN_ID_USA
#endif

char *GetLanguageAbByID(int id);
int GetLanguageIDByAb(char *ab);
int LanguageIDIsValid(int language_id);
int *LanguageIDListSupported(void);
char *GetLangOCXStrByID(int id);
int GetDateFormatByLanguageID(int lang_id);

#endif

/*
we find that if user change DNS server, daemon threads will not use new DNS server. 
so our solution is that when we find "/etc/resolv.conf " is changed,we will init the DNS server again by res_init().

*/
struct hostent *sc_gethostbyname(const char *name);

/*
sc_gethostbyname_r_block will be blocked when the other thread is using it in same programe.
and if call sc_gethostbyname_r_block, you must call free_gethostbyname_lock in programe.

we find that if user change DNS server, daemon threads will not use new DNS server. 
so our solution is that when we find "/etc/resolv.conf " is changed,we will init the DNS server again by res_init().

*/
struct hostent *sc_gethostbyname_r_block(const char *name, struct hostent *result_buf, char *buf, size_t buflen);

int free_gethostbyname_lock(void);

#ifdef _ONE_FW_MULTI_MODEL_
#define SC_MODEL_REAL_NAME_FILE			"/tmp/real_model"
/*
 * 0 success, others fail
 */
int sc_get_real_model_name(char *model, int model_len);

#endif

//#define SC_SKIP_FW_CHK_FILE				"/tmp/sc_fw_skip"

#ifdef _DEF_CONF_FILE_IN_FLASH_
#define SC_FACTORY_CONF_MODE			"/tmp/factory_conf_mode"
/*
 * Format is sErCoMmIsBu:LengthData\r\n
 */
#define CONF_FILE_DEF_PREFIX_STR	"#sErCoMmIsBu:"	// 13
#define CONF_FILE_PREFIX_VER_LEN	4
#define CONF_FILE_PREFIX_LEN_LEN	4

#endif

/*
Some for timezone
*/
//index of time zone 
#define TIMEZONE_MIN                    0  
#if  defined( _SUPPORT_NEW_TIMEZONE_VENEZUELA_)
#define TIMEZONE_MAX                    75
#elif defined( _SUPPORT_NEWEST_TIMEZONE_AS_VISTA_)
#define TIMEZONE_MAX                    84
#else
#define TIMEZONE_MAX                    74
#endif
#define TIMEZONE_DEFAULT				4

#define TZ_NO                    85

int *get_time_zone_table();

#ifdef _SUPPORT_NEWEST_TIMEZONE_AS_VISTA_
/*
Description: check the timezone whether the timezone is support before you set the timezone
return:  0 ->the timezone is valid;  -1 ->the timezone is unvalid
*/
int  TIME_TimezoneCheck(int timezone);
/*
Description: Correcting the value of timezone before you use the timezone
*/
void TIME_TimezoneCorrect(int * p_timezone);
#endif
//end some for timezone

#endif

