/***************************************************************
* (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/
#ifndef  _SYSTEM_DEF_H_
#define  _SYSTEM_DEF_H_

#include "sc_config.h"

#define  SYSTEM_OK		 0
#define  SYSTEM_ERROR	        -1

#define  DEV_LEN		16      
#define  DES_LEN		32
#define  HW_LEN			17	       /* 00:C0:02:12:34:56 */

#define  ADDR_LEN		49	       /* XXX.XXX... */
#define  DATE_LEN		20	       /* XX/XX/XXXX */
#define	 MODEL_LEN		10

//#define  VER_LEN        2              	/* AB CD - > A.BCR0D */
#define  VER_LEN        30            /* X.X.XX */

enum
{
	DATE_TYPE_INDEX_0,	// YYYY-MM-DD,
	DATE_TYPE_INDEX_1, 	// MM/DD/YYYY,
	DATE_TYPE_INDEX_2, 	// DD/MM/YYYY,
};
#ifdef _SC_SUPP_12HOUR_FORMAT_
#define DEF_TIME_TYPE   24         /*24:24hour,12:12-hour*/
#endif
#define DEF_DATE_TYPE	DATE_TYPE_INDEX_1 		/* 0: YYYY-MM-DD */
					/* 1: MM/DD/YYYY */
					/* 2: DD/MM/YYYY */
#define NTP_TIME_ZONE_INDEX_DEF 3  // time zone index default value

typedef struct SYS_TIME {
#ifdef _SC_SUPP_12HOUR_FORMAT_
   int timetype;
#endif
   int datetype;
   int t_index;		   	   /* The index of time zone */
   int sys_month;		   /* The month of system date   (1-12) */
   int sys_day;			   /* The day of system date     (1-31) */	
   int sys_year;                   /* The year of system date */
   int sys_hour;                   /* The hour of system date    (0-23) */
   int sys_min;                    /* The minutes of system date (0-59) */
   int sys_sec;                    /* The seconds of system date (0-59) */
} SYS_TIME;		    

#endif	/* _SYSTEM_DEF_H_ */
