/***************************************************************
* (C) COPYRIGHT SerComm Corporation All Rights Reserved, 2004.
*                    All Rights Reserved.
*
*      Use of this software is restricted to the terms and
*      conditions of SerComm's software license agreement.
*
*                        www.sercomm.com
****************************************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "ntp.h"
#include "SYS_log.h"
#include "conf_sec.h"
#include "ntp_config.h"
#include "PRO_file.h"
#include <unistd.h>

static int GetServer(int *en, char *server){
	FILE *fd;
	int ret;

	fd = fopen(SYSTEM_CONF,"rt");
	if(fd==NULL){
		return -1;
        }

	ret = PRO_GetInt(SEC_SYS, SYS_NTP_MODE, en, fd);	
	if (ret != 0) {
		fclose(fd);
		return -1;
	}

	ret = PRO_GetStr(SEC_SYS, SYS_NTP_SERVER, server, 50,fd);	
	if (ret != 0) {
		fclose(fd);
		return -1;
	}

	fclose(fd);

	return 0;
}

int main(int argc,char *argv[])
{
	int ret=0, ntp_en=0;
	char addr[16];
 	char server[NTP_ADDR_LEN+1];
#ifdef _USER_SETNTP_
	struct hostent *h;
#endif

	memset(addr, 0, sizeof(addr));
	memset(server,0,sizeof(server));
	GetServer(&ntp_en, server);
	if (0 == ntp_en)  //NTP disabled
	{
		return 0;
	}

	if(2 ==argc)
	{
#ifdef _USER_SETNTP_
		strcpy(server,argv[1]);
#endif
	} 

#ifdef _USER_SETNTP_
	if(!(h=gethostbyname(server)))
	{
	    AddLog(SYSLOG_SECTION_NTP,SYSLOG_WARNING,2);
	    ret =1;
	    sleep(1); //Need the delay the time change timing for HTTP-server to have 
				//enough time to response the HTML back.(sharp:may be update when boot)
	    return -1;
	}
	strcpy(addr,inet_ntoa(*((struct in_addr*)h->h_addr)));
#endif

	ret=NTP_update(addr);

#ifndef _USER_SETNTP_
	system("/usr/local/bin/ntp_setcron only_cron >/dev/null 2>/dev/null & ");
#endif

	return ret;
}
